﻿Imports System.Text

Imports System.Web.UI
Imports System.Web.UI.WebControls

Namespace PurchasingMgrWP
    Friend Class SilverlightObjectTagControl
        Inherits WebControl

        Private _Source As String
        Public Property Source As String
            Get
                Return _Source
            End Get
            Set(value As String)
                _Source = value
            End Set
        End Property

        Private _InitParameters As String
        Public Property InitParameters As String
            Get
                Return _InitParameters
            End Get
            Set(value As String)
                _InitParameters = value
            End Set
        End Property

        Protected Overrides Sub CreateChildControls()
            MyBase.CreateChildControls()

            If Source IsNot Nothing AndAlso Source <> "" Then
                Dim width = If(Me.Width = Unit.Empty, "400", Me.Width.ToString())
                Dim height = If(Me.Height = Unit.Empty, "300", Me.Height.ToString())

                Me.Controls.Add(New LiteralControl( _
                                "<div>" & _
                                "  <object data=""data:application/x-silverlight-2,"" type=""application/x-silverlight-2"" width=""" & width & """ height=""" & height & """>" & _
                                "      <param name=""source"" value=""" & Source & """/>" & _
                                "      <param name=""onerror"" value=""onSilverlightError"" />" & _
                                "      <param name=""background"" value=""white"" />" & _
                                "      <param name=""minRuntimeVersion"" value=""4.0.50826.0"" />" & _
                                "      <param name=""autoUpgrade"" value=""true"" />" & _
                                "      <param name=""initparams"" value=""" & InitParameters & """ />" & _
                                "      <a href=""http://go.microsoft.com/fwlink/?LinkID=149156&v=4.0.50826.0"" style=""text-decoration: none;"">" & _
                                "           <img src=""http://go.microsoft.com/fwlink/?LinkId=161376"" alt=""Get Microsoft Silverlight"" style=""border-style: none""/>" & _
                                "      </a>" & _
                                "  </object>" & _
                                "  <iframe id=""_sl_historyFrame"" style='visibility:hidden;height:0;width:0;border:0px'></iframe>" & _
                                "</div>"))

            End If
        End Sub
    End Class
End Namespace
